<?php if ( ! defined( 'ABSPATH' ) ) exit; ?>
<?php
	global 	$carspot_directory_url;
$carspot_directory_url=get_option('carspot_ep_url');					
if($carspot_directory_url==""){$carspot_directory_url='listing';}	

	
function carspot_taxonomy_add_custom_field() {
	$nonce = wp_create_nonce('carspot');
    ?>
    <div class="form-field term-image-wrap">
        <label for="cat-image"><?php esc_html_e('Image[Best: 250px X 380px]','carspot');?></label>
        <p><a href="#" class="aw_upload_image_button button button-secondary" id="upload_image_btn"><?php esc_html_e('Upload Image','carspot');?></a></p>
		<input type="hidden" name="carspot_wpnonce" value="<?php echo esc_attr($nonce); ?>">
        <input type="text" name="category_image_url" id="category_image_url"  value="" size="40" />
    </div>
    <?php
}
add_action( $carspot_directory_url.'-locations_add_form_fields', 'carspot_taxonomy_add_custom_field', 10, 2 );
 
function carspot_taxonomy_edit_custom_field($term) {
    $image = get_term_meta($term->term_id, 'carspot_term_image', true);
	$nonce = wp_create_nonce('carspot');
    ?>
    <tr class="form-field term-image-wrap">
        <th scope="row"><label for="category_image_url"><?php esc_html_e('Image [Best: 250px X 380px]','carspot');?></label></th>
        <td>
            <p><a href="#" class="aw_upload_image_button button button-secondary" id="upload_image_btn"><?php esc_html_e('Upload Image','carspot');?> </a>
				
				<img src="<?php echo esc_url($image); ?>" id="carspot_term_image_dis" width="100px">
			</p>
			
			<br/>
			
			<input type="hidden" name="carspot_wpnonce" value="<?php echo esc_attr($nonce); ?>">
            <input type="text" name="category_image_url"  id="category_image_url" value="<?php echo esc_url($image); ?>" size="40" />
        </td>
    </tr>
    <?php
}
add_action( $carspot_directory_url.'-locations_edit_form_fields', 'carspot_taxonomy_edit_custom_field', 10, 2 );

// Save data
add_action('created_'.$carspot_directory_url.'-locations', 'carspot_save_term_image', 10, 2);
function carspot_save_term_image($term_id, $tt_id) {
	
    if (isset($_POST['category_image_url']) && '' !== $_POST['category_image_url']){
        $group = sanitize_url($_POST['category_image_url']);
        add_term_meta($term_id, 'carspot_term_image', $group, true);
    }
}

///Now save the edited value
add_action('edited_'.$carspot_directory_url.'-locations', 'carspot_update_image_upload', 10, 2);
function carspot_update_image_upload($term_id, $tt_id) {
	
    if (isset($_POST['category_image_url']) && '' !== $_POST['category_image_url']){
        $group = sanitize_url($_POST['category_image_url']);
        update_term_meta($term_id, 'carspot_term_image', $group);
    }
}

// Js add
function carspot_image_uploader_enqueue() {
    global $typenow,$carspot_directory_url;	
    if( ($typenow == $carspot_directory_url) ) { 
		wp_enqueue_media();
        wp_register_script( 'carspot_meta-image', carspot_ep_URLPATH . 'admin/files/js/meta-media-uploader.js', array( 'jquery' ) );
        wp_localize_script( 'carspot_meta-image', 'meta_image',
            array(
                'title' => 'Upload an Image',
                'button' => 'Use this Image',
            )
        );
        wp_enqueue_script( 'carspot_meta-image' );
    }
}
add_action( 'admin_enqueue_scripts', 'carspot_image_uploader_enqueue' );